#include "Ch17p2_TileTransition.h"

// tile behavior classes ////////////////////////////////////////////////////

void CTileTransitionBehavior_Shrink::Setup(int iIndexX, int iIndexY, float x, float y, int iNumTilesX, int iNumTilesY, 
                                      int iVBIndex, VERTEX_XYZ_DIFFUSE_TEX1 *pVerts)
{
  CTileBehavior::Setup(iIndexX, iIndexY, x, y, iNumTilesX, iNumTilesY, iVBIndex, pVerts);
}

void CTileTransitionBehavior_Shrink::Update(float fElapsedTime, VERTEX_XYZ_DIFFUSE_TEX1 *pVerts)
{
  float fSubSpeedX = fElapsedTime * (2.0f / (m_iNumTilesX*2.0f)) / m_fDuration;
  float fSubSpeedY = fElapsedTime * (2.0f / (m_iNumTilesX*2.0f)) / m_fDuration;

  pVerts[m_iVBIndex].position.x -= fSubSpeedX;
  pVerts[m_iVBIndex].position.y -= fSubSpeedY;

  pVerts[m_iVBIndex+1].position.x -= fSubSpeedX;
  pVerts[m_iVBIndex+1].position.y += fSubSpeedY;

  pVerts[m_iVBIndex+2].position.x += fSubSpeedX;
  pVerts[m_iVBIndex+2].position.y += fSubSpeedY;

  pVerts[m_iVBIndex+3].position.x += fSubSpeedX;
  pVerts[m_iVBIndex+3].position.y -= fSubSpeedY;

  pVerts[m_iVBIndex+4].position.x -= fSubSpeedX;
  pVerts[m_iVBIndex+4].position.y -= fSubSpeedY;

  pVerts[m_iVBIndex+5].position.x += fSubSpeedX;
  pVerts[m_iVBIndex+5].position.y += fSubSpeedY;
}

